//
// File: MySQLParser.cc
// This code was produced by the dragon parser generator
//
#include "MySQLParser.h"
#include <lfcbase/Exception.h>
#include <lfcbase/StackT.h>

MySQLParser::ScannerStateEntry::ScannerStateEntry()
{
}

MySQLParser::ScannerStateEntry::ScannerStateEntry(int state, ScannerStateType type)
{
   _state = state;
   _type = type;
}

MySQLParser::ScannerStateEntry& MySQLParser::ScannerStateEntry::operator = (const MySQLParser::ScannerStateEntry& s)
{
   _state = s._state;
   _type = s._type;
   return(*this);
}

bool MySQLParser::ScannerStateEntry::operator == (const MySQLParser::ScannerStateEntry& s)
{
   if ( _state == s._state )
      return true;
   return false;
}

MySQLParser::ScannerStateType MySQLParser::ScannerStateEntry::getType()
{
   return _type;
}
int MySQLParser::ScannerStateEntry::getState()
{
   return _state;
}


MySQLParser::ScannerTransEntry::ScannerTransEntry()
{
}

MySQLParser::ScannerTransEntry::ScannerTransEntry(int state, char c)
{
   _state = state;
   _c = c;
}

MySQLParser::ScannerTransEntry::ScannerTransEntry(int state, char c, int fstate)
{
   _state = state;
   _c = c;
   _fstate = fstate;
}

MySQLParser::ScannerTransEntry& MySQLParser::ScannerTransEntry::operator = (const MySQLParser::ScannerTransEntry& s)
{
   _state = s._state;
   _c = s._c;
   _fstate = s._fstate;
   return(*this);
}

bool MySQLParser::ScannerTransEntry::operator == (const MySQLParser::ScannerTransEntry& s)
{
   if ( _state == s._state && _c == s._c)
      return true;
   return false;
}

int MySQLParser::ScannerTransEntry::getFState()
{
   return _fstate;
}


MySQLParser::Scanner::Scanner()
{
}


MySQLParser::Scanner::Scanner(Token t)
{
   _token = t;
}

MySQLParser::Token MySQLParser::Scanner::getToken()
{
   return _token;
}

void MySQLParser::Scanner::addState(ScannerStateEntry s)
{
   _stateList.Insert(s);
}

void MySQLParser::Scanner::addTransition(ScannerTransEntry t)
{
   _transList.Insert(t);
}

bool MySQLParser::Scanner::checkPattern(const Chain& p)
{
   unsigned long state = 0;
   ScannerStateEntry* pS = _stateList.First();
   while (pS)
   {
      if (pS->getType() == START || pS->getType() == ANY)
      {
         state = pS->getState();
         pS = 0;
      }
      else
      {
         pS = _stateList.Next();
      }
   }
   unsigned long i = 0;
   ScannerTransEntry* pT = 
   _transList.Find(ScannerTransEntry(state, p[i]));
   while (pT)
   {
      ScannerStateEntry* pS = _stateList.Find(ScannerStateEntry(pT->getFState())); 
      if (pS)
      {
         if ( ( i == p.length()-2 ) && ( pS->getType() == FINAL || pS->getType() == ANY))
         {
            return true;
         }
         else
         {
            state = pT->getFState();
         }
      }
      else
      {
         return false;
      }
      i++;
      pT = _transList.Find(ScannerTransEntry(state, p[i]));
   }
   return false;
}
MySQLParser::StackEntry::StackEntry()
{
   _symbol = NONE;
}

MySQLParser::StackEntry::StackEntry(Symbol symbol, int num, int state, Chain tval)
{
   _symbol=symbol;
   _num=num;
   _state=state;
   _tval=tval;
}

MySQLParser::StackEntry& MySQLParser::StackEntry::operator = (const MySQLParser::StackEntry& se)
{
   _symbol=se._symbol;
   _num=se._num;
   _state=se._state;
   _tval=se._tval;
   return(*this);
}

int MySQLParser::StackEntry::getState()
{
   return _state;
}
MySQLParser::Symbol MySQLParser::StackEntry::getSymbol()
{
   return _symbol;
}
Chain& MySQLParser::StackEntry::getTval()
{
   return _tval;
}

MySQLParser::ActionEntry::ActionEntry()
{
   _action=NULLACTION;
}

MySQLParser::ActionEntry::ActionEntry(Action action , int num)
{
   _action=action;
   _num=num;
}

bool MySQLParser::ActionEntry::operator == (const MySQLParser::ActionEntry& ae)
{
   if (_action == ae._action && _num == ae._num)
      return true;
   return false;
}

MySQLParser::ActionEntry& MySQLParser::ActionEntry::operator = (const MySQLParser::ActionEntry& ae)
{
   _action=ae._action;
   _num=ae._num;
   return(*this);
}

MySQLParser::Action MySQLParser::ActionEntry::getAction()
{
   return _action;
}

int MySQLParser::ActionEntry::getNum()
{
   return _num;
}

MySQLParser::ProdEntry::ProdEntry()
{
}

MySQLParser::ProdEntry::ProdEntry(int id)
{
   _id = id;
}

MySQLParser::ProdEntry::ProdEntry(int id, Production prod, int numSymbol)
{
   _id = id;
   _prod = prod;
   _numSymbol = numSymbol;
}

bool MySQLParser::ProdEntry::operator == (const MySQLParser::ProdEntry& pe)
{
   if (_id == pe._id)
      return true;
   return false;
}

MySQLParser::ProdEntry& MySQLParser::ProdEntry::operator = (const MySQLParser::ProdEntry& pe)
{
   _id = pe._id;
   _prod = pe._prod;
   _numSymbol = pe._numSymbol;
   return(*this);
}


int MySQLParser::ProdEntry::getId()
{
   return _id;
}

MySQLParser::Production MySQLParser::ProdEntry::getProd()
{
   return _prod;
}

int MySQLParser::ProdEntry::getNumSymbol()
{
   return _numSymbol;
}
void MySQLParser::loadScanner()
{
   Scanner s0(AUTOINCREMENT);
   s0.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(2 ,START));
   s0.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(8 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(9 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(10 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(11 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(12 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(13 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(14 ,FINAL));
   s0.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s0.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s0.addTransition(ScannerTransEntry(2 ,'a' ,0));
   s0.addTransition(ScannerTransEntry(3 ,'o' ,4));
   s0.addTransition(ScannerTransEntry(4 ,'_' ,5));
   s0.addTransition(ScannerTransEntry(5 ,'i' ,6));
   s0.addTransition(ScannerTransEntry(6 ,'n' ,7));
   s0.addTransition(ScannerTransEntry(7 ,'c' ,8));
   s0.addTransition(ScannerTransEntry(8 ,'r' ,9));
   s0.addTransition(ScannerTransEntry(9 ,'e' ,10));
   s0.addTransition(ScannerTransEntry(10 ,'m' ,11));
   s0.addTransition(ScannerTransEntry(11 ,'e' ,12));
   s0.addTransition(ScannerTransEntry(12 ,'n' ,13));
   s0.addTransition(ScannerTransEntry(13 ,'t' ,14));
   _scannerList.Insert(s0);

   Scanner s1(BOOL);
   s1.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s1.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s1.addState(ScannerStateEntry(2 ,START));
   s1.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s1.addState(ScannerStateEntry(4 ,FINAL));
   s1.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s1.addTransition(ScannerTransEntry(1 ,'o' ,3));
   s1.addTransition(ScannerTransEntry(2 ,'b' ,0));
   s1.addTransition(ScannerTransEntry(3 ,'l' ,4));
   _scannerList.Insert(s1);

   Scanner s2(CHARSET);
   s2.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s2.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s2.addState(ScannerStateEntry(2 ,START));
   s2.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s2.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s2.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s2.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s2.addState(ScannerStateEntry(7 ,FINAL));
   s2.addTransition(ScannerTransEntry(0 ,'h' ,1));
   s2.addTransition(ScannerTransEntry(1 ,'a' ,3));
   s2.addTransition(ScannerTransEntry(2 ,'c' ,0));
   s2.addTransition(ScannerTransEntry(3 ,'r' ,4));
   s2.addTransition(ScannerTransEntry(4 ,'s' ,5));
   s2.addTransition(ScannerTransEntry(5 ,'e' ,6));
   s2.addTransition(ScannerTransEntry(6 ,'t' ,7));
   _scannerList.Insert(s2);

   Scanner s3(COLLATE);
   s3.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s3.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s3.addState(ScannerStateEntry(2 ,START));
   s3.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s3.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s3.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s3.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s3.addState(ScannerStateEntry(7 ,FINAL));
   s3.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s3.addTransition(ScannerTransEntry(1 ,'l' ,3));
   s3.addTransition(ScannerTransEntry(2 ,'c' ,0));
   s3.addTransition(ScannerTransEntry(3 ,'l' ,4));
   s3.addTransition(ScannerTransEntry(4 ,'a' ,5));
   s3.addTransition(ScannerTransEntry(5 ,'t' ,6));
   s3.addTransition(ScannerTransEntry(6 ,'e' ,7));
   _scannerList.Insert(s3);

   Scanner s4(CREATE);
   s4.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s4.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s4.addState(ScannerStateEntry(2 ,START));
   s4.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s4.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s4.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s4.addState(ScannerStateEntry(6 ,FINAL));
   s4.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s4.addTransition(ScannerTransEntry(1 ,'e' ,3));
   s4.addTransition(ScannerTransEntry(2 ,'c' ,0));
   s4.addTransition(ScannerTransEntry(3 ,'a' ,4));
   s4.addTransition(ScannerTransEntry(4 ,'t' ,5));
   s4.addTransition(ScannerTransEntry(5 ,'e' ,6));
   _scannerList.Insert(s4);

   Scanner s5(CURRENTTIMESTAMP);
   s5.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s5.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s5.addState(ScannerStateEntry(2 ,START));
   s5.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s5.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s5.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s5.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s5.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s5.addState(ScannerStateEntry(8 ,INTERMEDIATE));
   s5.addState(ScannerStateEntry(9 ,INTERMEDIATE));
   s5.addState(ScannerStateEntry(10 ,INTERMEDIATE));
   s5.addState(ScannerStateEntry(11 ,INTERMEDIATE));
   s5.addState(ScannerStateEntry(12 ,INTERMEDIATE));
   s5.addState(ScannerStateEntry(13 ,INTERMEDIATE));
   s5.addState(ScannerStateEntry(14 ,INTERMEDIATE));
   s5.addState(ScannerStateEntry(15 ,INTERMEDIATE));
   s5.addState(ScannerStateEntry(16 ,INTERMEDIATE));
   s5.addState(ScannerStateEntry(17 ,FINAL));
   s5.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s5.addTransition(ScannerTransEntry(1 ,'r' ,3));
   s5.addTransition(ScannerTransEntry(2 ,'c' ,0));
   s5.addTransition(ScannerTransEntry(3 ,'r' ,4));
   s5.addTransition(ScannerTransEntry(4 ,'e' ,5));
   s5.addTransition(ScannerTransEntry(5 ,'n' ,6));
   s5.addTransition(ScannerTransEntry(6 ,'t' ,7));
   s5.addTransition(ScannerTransEntry(7 ,'_' ,8));
   s5.addTransition(ScannerTransEntry(8 ,'t' ,9));
   s5.addTransition(ScannerTransEntry(9 ,'i' ,10));
   s5.addTransition(ScannerTransEntry(10 ,'m' ,11));
   s5.addTransition(ScannerTransEntry(11 ,'e' ,12));
   s5.addTransition(ScannerTransEntry(12 ,'s' ,13));
   s5.addTransition(ScannerTransEntry(13 ,'t' ,14));
   s5.addTransition(ScannerTransEntry(14 ,'a' ,15));
   s5.addTransition(ScannerTransEntry(15 ,'m' ,16));
   s5.addTransition(ScannerTransEntry(16 ,'p' ,17));
   _scannerList.Insert(s5);

   Scanner s6(DATETIME);
   s6.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s6.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s6.addState(ScannerStateEntry(2 ,START));
   s6.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s6.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s6.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s6.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s6.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s6.addState(ScannerStateEntry(8 ,FINAL));
   s6.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s6.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s6.addTransition(ScannerTransEntry(2 ,'d' ,0));
   s6.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s6.addTransition(ScannerTransEntry(4 ,'t' ,5));
   s6.addTransition(ScannerTransEntry(5 ,'i' ,6));
   s6.addTransition(ScannerTransEntry(6 ,'m' ,7));
   s6.addTransition(ScannerTransEntry(7 ,'e' ,8));
   _scannerList.Insert(s6);

   Scanner s7(DECIMAL);
   s7.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s7.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s7.addState(ScannerStateEntry(2 ,START));
   s7.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s7.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s7.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s7.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s7.addState(ScannerStateEntry(7 ,FINAL));
   s7.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s7.addTransition(ScannerTransEntry(1 ,'c' ,3));
   s7.addTransition(ScannerTransEntry(2 ,'d' ,0));
   s7.addTransition(ScannerTransEntry(3 ,'i' ,4));
   s7.addTransition(ScannerTransEntry(4 ,'m' ,5));
   s7.addTransition(ScannerTransEntry(5 ,'a' ,6));
   s7.addTransition(ScannerTransEntry(6 ,'l' ,7));
   _scannerList.Insert(s7);

   Scanner s8(DEFAULT);
   s8.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s8.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s8.addState(ScannerStateEntry(2 ,START));
   s8.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s8.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s8.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s8.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s8.addState(ScannerStateEntry(7 ,FINAL));
   s8.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s8.addTransition(ScannerTransEntry(1 ,'f' ,3));
   s8.addTransition(ScannerTransEntry(2 ,'d' ,0));
   s8.addTransition(ScannerTransEntry(3 ,'a' ,4));
   s8.addTransition(ScannerTransEntry(4 ,'u' ,5));
   s8.addTransition(ScannerTransEntry(5 ,'l' ,6));
   s8.addTransition(ScannerTransEntry(6 ,'t' ,7));
   _scannerList.Insert(s8);

   Scanner s9(DOUBLE);
   s9.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s9.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s9.addState(ScannerStateEntry(2 ,START));
   s9.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s9.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s9.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s9.addState(ScannerStateEntry(6 ,FINAL));
   s9.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s9.addTransition(ScannerTransEntry(1 ,'u' ,3));
   s9.addTransition(ScannerTransEntry(2 ,'d' ,0));
   s9.addTransition(ScannerTransEntry(3 ,'b' ,4));
   s9.addTransition(ScannerTransEntry(4 ,'l' ,5));
   s9.addTransition(ScannerTransEntry(5 ,'e' ,6));
   _scannerList.Insert(s9);

   Scanner s10(DROP);
   s10.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s10.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s10.addState(ScannerStateEntry(2 ,START));
   s10.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s10.addState(ScannerStateEntry(4 ,FINAL));
   s10.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s10.addTransition(ScannerTransEntry(1 ,'o' ,3));
   s10.addTransition(ScannerTransEntry(2 ,'d' ,0));
   s10.addTransition(ScannerTransEntry(3 ,'p' ,4));
   _scannerList.Insert(s10);

   Scanner s11(ENUM);
   s11.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s11.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s11.addState(ScannerStateEntry(2 ,START));
   s11.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s11.addState(ScannerStateEntry(4 ,FINAL));
   s11.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s11.addTransition(ScannerTransEntry(1 ,'u' ,3));
   s11.addTransition(ScannerTransEntry(2 ,'e' ,0));
   s11.addTransition(ScannerTransEntry(3 ,'m' ,4));
   _scannerList.Insert(s11);

   Scanner s12(ENGINE);
   s12.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s12.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s12.addState(ScannerStateEntry(2 ,START));
   s12.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s12.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s12.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s12.addState(ScannerStateEntry(6 ,FINAL));
   s12.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s12.addTransition(ScannerTransEntry(1 ,'g' ,3));
   s12.addTransition(ScannerTransEntry(2 ,'e' ,0));
   s12.addTransition(ScannerTransEntry(3 ,'i' ,4));
   s12.addTransition(ScannerTransEntry(4 ,'n' ,5));
   s12.addTransition(ScannerTransEntry(5 ,'e' ,6));
   _scannerList.Insert(s12);

   Scanner s13(EXISTS);
   s13.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s13.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s13.addState(ScannerStateEntry(2 ,START));
   s13.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s13.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s13.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s13.addState(ScannerStateEntry(6 ,FINAL));
   s13.addTransition(ScannerTransEntry(0 ,'x' ,1));
   s13.addTransition(ScannerTransEntry(1 ,'i' ,3));
   s13.addTransition(ScannerTransEntry(2 ,'e' ,0));
   s13.addTransition(ScannerTransEntry(3 ,'s' ,4));
   s13.addTransition(ScannerTransEntry(4 ,'t' ,5));
   s13.addTransition(ScannerTransEntry(5 ,'s' ,6));
   _scannerList.Insert(s13);

   Scanner s14(FALSEVAL);
   s14.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s14.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s14.addState(ScannerStateEntry(2 ,START));
   s14.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s14.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s14.addState(ScannerStateEntry(5 ,FINAL));
   s14.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s14.addTransition(ScannerTransEntry(1 ,'l' ,3));
   s14.addTransition(ScannerTransEntry(2 ,'f' ,0));
   s14.addTransition(ScannerTransEntry(3 ,'s' ,4));
   s14.addTransition(ScannerTransEntry(4 ,'e' ,5));
   _scannerList.Insert(s14);

   Scanner s15(FLOAT);
   s15.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s15.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s15.addState(ScannerStateEntry(2 ,START));
   s15.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s15.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s15.addState(ScannerStateEntry(5 ,FINAL));
   s15.addTransition(ScannerTransEntry(0 ,'l' ,1));
   s15.addTransition(ScannerTransEntry(1 ,'o' ,3));
   s15.addTransition(ScannerTransEntry(2 ,'f' ,0));
   s15.addTransition(ScannerTransEntry(3 ,'a' ,4));
   s15.addTransition(ScannerTransEntry(4 ,'t' ,5));
   _scannerList.Insert(s15);

   Scanner s16(FOREIGN);
   s16.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s16.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s16.addState(ScannerStateEntry(2 ,START));
   s16.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s16.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s16.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s16.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s16.addState(ScannerStateEntry(7 ,FINAL));
   s16.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s16.addTransition(ScannerTransEntry(1 ,'r' ,3));
   s16.addTransition(ScannerTransEntry(2 ,'f' ,0));
   s16.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s16.addTransition(ScannerTransEntry(4 ,'i' ,5));
   s16.addTransition(ScannerTransEntry(5 ,'g' ,6));
   s16.addTransition(ScannerTransEntry(6 ,'n' ,7));
   _scannerList.Insert(s16);

   Scanner s17(IF);
   s17.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s17.addState(ScannerStateEntry(1 ,FINAL));
   s17.addState(ScannerStateEntry(2 ,START));
   s17.addTransition(ScannerTransEntry(0 ,'f' ,1));
   s17.addTransition(ScannerTransEntry(2 ,'i' ,0));
   _scannerList.Insert(s17);

   Scanner s18(INDEX);
   s18.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s18.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s18.addState(ScannerStateEntry(2 ,START));
   s18.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s18.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s18.addState(ScannerStateEntry(5 ,FINAL));
   s18.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s18.addTransition(ScannerTransEntry(1 ,'d' ,3));
   s18.addTransition(ScannerTransEntry(2 ,'i' ,0));
   s18.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s18.addTransition(ScannerTransEntry(4 ,'x' ,5));
   _scannerList.Insert(s18);

   Scanner s19(INT);
   s19.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s19.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s19.addState(ScannerStateEntry(2 ,START));
   s19.addState(ScannerStateEntry(3 ,FINAL));
   s19.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s19.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s19.addTransition(ScannerTransEntry(2 ,'i' ,0));
   _scannerList.Insert(s19);

   Scanner s20(INTO);
   s20.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s20.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s20.addState(ScannerStateEntry(2 ,START));
   s20.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s20.addState(ScannerStateEntry(4 ,FINAL));
   s20.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s20.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s20.addTransition(ScannerTransEntry(2 ,'i' ,0));
   s20.addTransition(ScannerTransEntry(3 ,'o' ,4));
   _scannerList.Insert(s20);

   Scanner s21(INSERT);
   s21.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s21.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s21.addState(ScannerStateEntry(2 ,START));
   s21.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s21.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s21.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s21.addState(ScannerStateEntry(6 ,FINAL));
   s21.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s21.addTransition(ScannerTransEntry(1 ,'s' ,3));
   s21.addTransition(ScannerTransEntry(2 ,'i' ,0));
   s21.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s21.addTransition(ScannerTransEntry(4 ,'r' ,5));
   s21.addTransition(ScannerTransEntry(5 ,'t' ,6));
   _scannerList.Insert(s21);

   Scanner s22(KEY);
   s22.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s22.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s22.addState(ScannerStateEntry(2 ,START));
   s22.addState(ScannerStateEntry(3 ,FINAL));
   s22.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s22.addTransition(ScannerTransEntry(1 ,'y' ,3));
   s22.addTransition(ScannerTransEntry(2 ,'k' ,0));
   _scannerList.Insert(s22);

   Scanner s23(LOCK);
   s23.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s23.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s23.addState(ScannerStateEntry(2 ,START));
   s23.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s23.addState(ScannerStateEntry(4 ,FINAL));
   s23.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s23.addTransition(ScannerTransEntry(1 ,'c' ,3));
   s23.addTransition(ScannerTransEntry(2 ,'l' ,0));
   s23.addTransition(ScannerTransEntry(3 ,'k' ,4));
   _scannerList.Insert(s23);

   Scanner s24(LONGBLOB);
   s24.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s24.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s24.addState(ScannerStateEntry(2 ,START));
   s24.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s24.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s24.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s24.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s24.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s24.addState(ScannerStateEntry(8 ,FINAL));
   s24.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s24.addTransition(ScannerTransEntry(1 ,'n' ,3));
   s24.addTransition(ScannerTransEntry(2 ,'l' ,0));
   s24.addTransition(ScannerTransEntry(3 ,'g' ,4));
   s24.addTransition(ScannerTransEntry(4 ,'b' ,5));
   s24.addTransition(ScannerTransEntry(5 ,'l' ,6));
   s24.addTransition(ScannerTransEntry(6 ,'o' ,7));
   s24.addTransition(ScannerTransEntry(7 ,'b' ,8));
   _scannerList.Insert(s24);

   Scanner s25(MEDIUMTEXT);
   s25.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s25.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s25.addState(ScannerStateEntry(2 ,START));
   s25.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s25.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s25.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s25.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s25.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s25.addState(ScannerStateEntry(8 ,INTERMEDIATE));
   s25.addState(ScannerStateEntry(9 ,INTERMEDIATE));
   s25.addState(ScannerStateEntry(10 ,FINAL));
   s25.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s25.addTransition(ScannerTransEntry(1 ,'d' ,3));
   s25.addTransition(ScannerTransEntry(2 ,'m' ,0));
   s25.addTransition(ScannerTransEntry(3 ,'i' ,4));
   s25.addTransition(ScannerTransEntry(4 ,'u' ,5));
   s25.addTransition(ScannerTransEntry(5 ,'m' ,6));
   s25.addTransition(ScannerTransEntry(6 ,'t' ,7));
   s25.addTransition(ScannerTransEntry(7 ,'e' ,8));
   s25.addTransition(ScannerTransEntry(8 ,'x' ,9));
   s25.addTransition(ScannerTransEntry(9 ,'t' ,10));
   _scannerList.Insert(s25);

   Scanner s26(NOT);
   s26.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s26.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s26.addState(ScannerStateEntry(2 ,START));
   s26.addState(ScannerStateEntry(3 ,FINAL));
   s26.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s26.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s26.addTransition(ScannerTransEntry(2 ,'n' ,0));
   _scannerList.Insert(s26);

   Scanner s27(NULLTOKEN);
   s27.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s27.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s27.addState(ScannerStateEntry(2 ,START));
   s27.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s27.addState(ScannerStateEntry(4 ,FINAL));
   s27.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s27.addTransition(ScannerTransEntry(1 ,'l' ,3));
   s27.addTransition(ScannerTransEntry(2 ,'n' ,0));
   s27.addTransition(ScannerTransEntry(3 ,'l' ,4));
   _scannerList.Insert(s27);

   Scanner s28(ON);
   s28.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s28.addState(ScannerStateEntry(1 ,FINAL));
   s28.addState(ScannerStateEntry(2 ,START));
   s28.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s28.addTransition(ScannerTransEntry(2 ,'o' ,0));
   _scannerList.Insert(s28);

   Scanner s29(PRIMARY);
   s29.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s29.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s29.addState(ScannerStateEntry(2 ,START));
   s29.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s29.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s29.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s29.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s29.addState(ScannerStateEntry(7 ,FINAL));
   s29.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s29.addTransition(ScannerTransEntry(1 ,'i' ,3));
   s29.addTransition(ScannerTransEntry(2 ,'p' ,0));
   s29.addTransition(ScannerTransEntry(3 ,'m' ,4));
   s29.addTransition(ScannerTransEntry(4 ,'a' ,5));
   s29.addTransition(ScannerTransEntry(5 ,'r' ,6));
   s29.addTransition(ScannerTransEntry(6 ,'y' ,7));
   _scannerList.Insert(s29);

   Scanner s30(SET);
   s30.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s30.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s30.addState(ScannerStateEntry(2 ,START));
   s30.addState(ScannerStateEntry(3 ,FINAL));
   s30.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s30.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s30.addTransition(ScannerTransEntry(2 ,'s' ,0));
   _scannerList.Insert(s30);

   Scanner s31(TABLE);
   s31.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s31.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s31.addState(ScannerStateEntry(2 ,START));
   s31.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s31.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s31.addState(ScannerStateEntry(5 ,FINAL));
   s31.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s31.addTransition(ScannerTransEntry(1 ,'b' ,3));
   s31.addTransition(ScannerTransEntry(2 ,'t' ,0));
   s31.addTransition(ScannerTransEntry(3 ,'l' ,4));
   s31.addTransition(ScannerTransEntry(4 ,'e' ,5));
   _scannerList.Insert(s31);

   Scanner s32(TABLES);
   s32.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s32.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s32.addState(ScannerStateEntry(2 ,START));
   s32.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s32.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s32.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s32.addState(ScannerStateEntry(6 ,FINAL));
   s32.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s32.addTransition(ScannerTransEntry(1 ,'b' ,3));
   s32.addTransition(ScannerTransEntry(2 ,'t' ,0));
   s32.addTransition(ScannerTransEntry(3 ,'l' ,4));
   s32.addTransition(ScannerTransEntry(4 ,'e' ,5));
   s32.addTransition(ScannerTransEntry(5 ,'s' ,6));
   _scannerList.Insert(s32);

   Scanner s33(TEXT);
   s33.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s33.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s33.addState(ScannerStateEntry(2 ,START));
   s33.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s33.addState(ScannerStateEntry(4 ,FINAL));
   s33.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s33.addTransition(ScannerTransEntry(1 ,'x' ,3));
   s33.addTransition(ScannerTransEntry(2 ,'t' ,0));
   s33.addTransition(ScannerTransEntry(3 ,'t' ,4));
   _scannerList.Insert(s33);

   Scanner s34(TIMESTAMP);
   s34.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s34.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s34.addState(ScannerStateEntry(2 ,START));
   s34.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s34.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s34.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s34.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s34.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s34.addState(ScannerStateEntry(8 ,INTERMEDIATE));
   s34.addState(ScannerStateEntry(9 ,FINAL));
   s34.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s34.addTransition(ScannerTransEntry(1 ,'m' ,3));
   s34.addTransition(ScannerTransEntry(2 ,'t' ,0));
   s34.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s34.addTransition(ScannerTransEntry(4 ,'s' ,5));
   s34.addTransition(ScannerTransEntry(5 ,'t' ,6));
   s34.addTransition(ScannerTransEntry(6 ,'a' ,7));
   s34.addTransition(ScannerTransEntry(7 ,'m' ,8));
   s34.addTransition(ScannerTransEntry(8 ,'p' ,9));
   _scannerList.Insert(s34);

   Scanner s35(UNLOCK);
   s35.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s35.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s35.addState(ScannerStateEntry(2 ,START));
   s35.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s35.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s35.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s35.addState(ScannerStateEntry(6 ,FINAL));
   s35.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s35.addTransition(ScannerTransEntry(1 ,'l' ,3));
   s35.addTransition(ScannerTransEntry(2 ,'u' ,0));
   s35.addTransition(ScannerTransEntry(3 ,'o' ,4));
   s35.addTransition(ScannerTransEntry(4 ,'c' ,5));
   s35.addTransition(ScannerTransEntry(5 ,'k' ,6));
   _scannerList.Insert(s35);

   Scanner s36(UNIQUE);
   s36.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s36.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s36.addState(ScannerStateEntry(2 ,START));
   s36.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s36.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s36.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s36.addState(ScannerStateEntry(6 ,FINAL));
   s36.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s36.addTransition(ScannerTransEntry(1 ,'i' ,3));
   s36.addTransition(ScannerTransEntry(2 ,'u' ,0));
   s36.addTransition(ScannerTransEntry(3 ,'q' ,4));
   s36.addTransition(ScannerTransEntry(4 ,'u' ,5));
   s36.addTransition(ScannerTransEntry(5 ,'e' ,6));
   _scannerList.Insert(s36);

   Scanner s37(UNSIGNED);
   s37.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s37.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s37.addState(ScannerStateEntry(2 ,START));
   s37.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s37.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s37.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s37.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s37.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s37.addState(ScannerStateEntry(8 ,FINAL));
   s37.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s37.addTransition(ScannerTransEntry(1 ,'s' ,3));
   s37.addTransition(ScannerTransEntry(2 ,'u' ,0));
   s37.addTransition(ScannerTransEntry(3 ,'i' ,4));
   s37.addTransition(ScannerTransEntry(4 ,'g' ,5));
   s37.addTransition(ScannerTransEntry(5 ,'n' ,6));
   s37.addTransition(ScannerTransEntry(6 ,'e' ,7));
   s37.addTransition(ScannerTransEntry(7 ,'d' ,8));
   _scannerList.Insert(s37);

   Scanner s38(UPDATE);
   s38.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s38.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s38.addState(ScannerStateEntry(2 ,START));
   s38.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s38.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s38.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s38.addState(ScannerStateEntry(6 ,FINAL));
   s38.addTransition(ScannerTransEntry(0 ,'p' ,1));
   s38.addTransition(ScannerTransEntry(1 ,'d' ,3));
   s38.addTransition(ScannerTransEntry(2 ,'u' ,0));
   s38.addTransition(ScannerTransEntry(3 ,'a' ,4));
   s38.addTransition(ScannerTransEntry(4 ,'t' ,5));
   s38.addTransition(ScannerTransEntry(5 ,'e' ,6));
   _scannerList.Insert(s38);

   Scanner s39(VALUES);
   s39.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s39.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s39.addState(ScannerStateEntry(2 ,START));
   s39.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s39.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s39.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s39.addState(ScannerStateEntry(6 ,FINAL));
   s39.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'l' ,3));
   s39.addTransition(ScannerTransEntry(2 ,'v' ,0));
   s39.addTransition(ScannerTransEntry(3 ,'u' ,4));
   s39.addTransition(ScannerTransEntry(4 ,'e' ,5));
   s39.addTransition(ScannerTransEntry(5 ,'s' ,6));
   _scannerList.Insert(s39);

   Scanner s40(VARCHAR);
   s40.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s40.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s40.addState(ScannerStateEntry(2 ,START));
   s40.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s40.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s40.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s40.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s40.addState(ScannerStateEntry(7 ,FINAL));
   s40.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'r' ,3));
   s40.addTransition(ScannerTransEntry(2 ,'v' ,0));
   s40.addTransition(ScannerTransEntry(3 ,'c' ,4));
   s40.addTransition(ScannerTransEntry(4 ,'h' ,5));
   s40.addTransition(ScannerTransEntry(5 ,'a' ,6));
   s40.addTransition(ScannerTransEntry(6 ,'r' ,7));
   _scannerList.Insert(s40);

   Scanner s41(WRITE);
   s41.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s41.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s41.addState(ScannerStateEntry(2 ,START));
   s41.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s41.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s41.addState(ScannerStateEntry(5 ,FINAL));
   s41.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s41.addTransition(ScannerTransEntry(1 ,'i' ,3));
   s41.addTransition(ScannerTransEntry(2 ,'w' ,0));
   s41.addTransition(ScannerTransEntry(3 ,'t' ,4));
   s41.addTransition(ScannerTransEntry(4 ,'e' ,5));
   _scannerList.Insert(s41);

   Scanner s42(MINUS);
   s42.addState(ScannerStateEntry(0 ,START));
   s42.addState(ScannerStateEntry(1 ,FINAL));
   s42.addTransition(ScannerTransEntry(0 ,'-' ,1));
   _scannerList.Insert(s42);

   Scanner s43(EQU);
   s43.addState(ScannerStateEntry(0 ,START));
   s43.addState(ScannerStateEntry(1 ,FINAL));
   s43.addTransition(ScannerTransEntry(0 ,'=' ,1));
   _scannerList.Insert(s43);

   Scanner s44(KSEP);
   s44.addState(ScannerStateEntry(0 ,START));
   s44.addState(ScannerStateEntry(1 ,FINAL));
   s44.addTransition(ScannerTransEntry(0 ,',' ,1));
   _scannerList.Insert(s44);

   Scanner s45(LB);
   s45.addState(ScannerStateEntry(0 ,START));
   s45.addState(ScannerStateEntry(1 ,FINAL));
   s45.addTransition(ScannerTransEntry(0 ,'(' ,1));
   _scannerList.Insert(s45);

   Scanner s46(RB);
   s46.addState(ScannerStateEntry(0 ,START));
   s46.addState(ScannerStateEntry(1 ,FINAL));
   s46.addTransition(ScannerTransEntry(0 ,')' ,1));
   _scannerList.Insert(s46);

   Scanner s47(SEMICOLON);
   s47.addState(ScannerStateEntry(0 ,START));
   s47.addState(ScannerStateEntry(1 ,FINAL));
   s47.addTransition(ScannerTransEntry(0 ,';' ,1));
   _scannerList.Insert(s47);

   Scanner s48(INTVAL);
   s48.addState(ScannerStateEntry(0 ,START));
   s48.addState(ScannerStateEntry(1 ,FINAL));
   s48.addState(ScannerStateEntry(2 ,FINAL));
   s48.addTransition(ScannerTransEntry(0 ,'1' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'2' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'3' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'4' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'5' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'6' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'7' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'8' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'9' ,1));
   s48.addTransition(ScannerTransEntry(0 ,'0' ,2));
   s48.addTransition(ScannerTransEntry(1 ,'0' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'1' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'2' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'3' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'4' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'5' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'6' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'7' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'8' ,1));
   s48.addTransition(ScannerTransEntry(1 ,'9' ,1));
   _scannerList.Insert(s48);

   Scanner s49(FLOATVAL);
   s49.addState(ScannerStateEntry(0 ,START));
   s49.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s49.addState(ScannerStateEntry(2 ,INTERMEDIATE));
   s49.addState(ScannerStateEntry(3 ,FINAL));
   s49.addTransition(ScannerTransEntry(0 ,'1' ,1));
   s49.addTransition(ScannerTransEntry(0 ,'2' ,1));
   s49.addTransition(ScannerTransEntry(0 ,'3' ,1));
   s49.addTransition(ScannerTransEntry(0 ,'4' ,1));
   s49.addTransition(ScannerTransEntry(0 ,'5' ,1));
   s49.addTransition(ScannerTransEntry(0 ,'6' ,1));
   s49.addTransition(ScannerTransEntry(0 ,'7' ,1));
   s49.addTransition(ScannerTransEntry(0 ,'8' ,1));
   s49.addTransition(ScannerTransEntry(0 ,'9' ,1));
   s49.addTransition(ScannerTransEntry(0 ,'0' ,2));
   s49.addTransition(ScannerTransEntry(1 ,'0' ,1));
   s49.addTransition(ScannerTransEntry(1 ,'1' ,1));
   s49.addTransition(ScannerTransEntry(1 ,'2' ,1));
   s49.addTransition(ScannerTransEntry(1 ,'3' ,1));
   s49.addTransition(ScannerTransEntry(1 ,'4' ,1));
   s49.addTransition(ScannerTransEntry(1 ,'5' ,1));
   s49.addTransition(ScannerTransEntry(1 ,'6' ,1));
   s49.addTransition(ScannerTransEntry(1 ,'7' ,1));
   s49.addTransition(ScannerTransEntry(1 ,'8' ,1));
   s49.addTransition(ScannerTransEntry(1 ,'9' ,1));
   s49.addTransition(ScannerTransEntry(1 ,'.' ,3));
   s49.addTransition(ScannerTransEntry(2 ,'.' ,3));
   s49.addTransition(ScannerTransEntry(3 ,'0' ,3));
   s49.addTransition(ScannerTransEntry(3 ,'1' ,3));
   s49.addTransition(ScannerTransEntry(3 ,'2' ,3));
   s49.addTransition(ScannerTransEntry(3 ,'3' ,3));
   s49.addTransition(ScannerTransEntry(3 ,'4' ,3));
   s49.addTransition(ScannerTransEntry(3 ,'5' ,3));
   s49.addTransition(ScannerTransEntry(3 ,'6' ,3));
   s49.addTransition(ScannerTransEntry(3 ,'7' ,3));
   s49.addTransition(ScannerTransEntry(3 ,'8' ,3));
   s49.addTransition(ScannerTransEntry(3 ,'9' ,3));
   _scannerList.Insert(s49);

   Scanner s50(IDENTIFIER);
   s50.addState(ScannerStateEntry(0 ,FINAL));
   s50.addState(ScannerStateEntry(1 ,START));
   s50.addState(ScannerStateEntry(2 ,INTERMEDIATE));
   s50.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s50.addState(ScannerStateEntry(4 ,FINAL));
   s50.addTransition(ScannerTransEntry(0 ,'0' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'1' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'2' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'3' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'4' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'5' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'6' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'7' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'8' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'9' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'@' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'A' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'B' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'C' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'D' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'E' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'F' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'G' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'H' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'I' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'J' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'K' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'L' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'M' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'N' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'O' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'P' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'Q' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'R' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'S' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'T' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'U' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'V' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'W' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'X' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'Y' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'Z' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'_' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'a' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'b' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'c' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'d' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'e' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'f' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'g' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'h' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'i' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'j' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'k' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'l' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'m' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'n' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'o' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'p' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'q' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'r' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'s' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'t' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'u' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'v' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'w' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'x' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'y' ,0));
   s50.addTransition(ScannerTransEntry(0 ,'z' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'@' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'A' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'B' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'C' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'D' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'E' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'F' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'G' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'H' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'I' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'J' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'K' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'L' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'M' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'N' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'O' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'P' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'Q' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'R' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'S' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'T' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'U' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'V' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'W' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'X' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'Y' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'Z' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'a' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'b' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'c' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'d' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'e' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'f' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'g' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'h' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'i' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'j' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'k' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'l' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'m' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'n' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'o' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'p' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'q' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'r' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'s' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'t' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'u' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'v' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'w' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'x' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'y' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'z' ,0));
   s50.addTransition(ScannerTransEntry(1 ,'`' ,2));
   s50.addTransition(ScannerTransEntry(2 ,'@' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'A' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'B' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'C' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'D' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'E' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'F' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'G' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'H' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'I' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'J' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'K' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'L' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'M' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'N' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'O' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'P' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'Q' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'R' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'S' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'T' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'U' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'V' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'W' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'X' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'Y' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'Z' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'a' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'b' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'c' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'d' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'e' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'f' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'g' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'h' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'i' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'j' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'k' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'l' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'m' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'n' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'o' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'p' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'q' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'r' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'s' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'t' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'u' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'v' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'w' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'x' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'y' ,3));
   s50.addTransition(ScannerTransEntry(2 ,'z' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'0' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'1' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'2' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'3' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'4' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'5' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'6' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'7' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'8' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'9' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'@' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'A' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'B' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'C' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'D' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'E' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'F' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'G' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'H' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'I' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'J' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'K' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'L' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'M' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'N' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'O' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'P' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'Q' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'R' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'S' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'T' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'U' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'V' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'W' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'X' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'Y' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'Z' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'_' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'a' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'b' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'c' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'d' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'e' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'f' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'g' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'h' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'i' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'j' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'k' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'l' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'m' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'n' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'o' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'p' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'q' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'r' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'s' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'t' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'u' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'v' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'w' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'x' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'y' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'z' ,3));
   s50.addTransition(ScannerTransEntry(3 ,'`' ,4));
   _scannerList.Insert(s50);

}
void MySQLParser::loadParser0()
{
   _actionMap[139][AUTOINCREMENT] = ActionEntry(REDUCE, 30);
   _actionMap[139][RB] = ActionEntry(REDUCE, 30);
   _actionMap[139][KSEP] = ActionEntry(REDUCE, 30);
   _actionMap[140][UNSIGNED] = ActionEntry(REDUCE, 64);
   _actionMap[140][NULLTOKEN] = ActionEntry(REDUCE, 64);
   _actionMap[140][NOT] = ActionEntry(REDUCE, 64);
   _actionMap[140][DEFAULT] = ActionEntry(REDUCE, 64);
   _actionMap[140][ON] = ActionEntry(REDUCE, 64);
   _actionMap[140][AUTOINCREMENT] = ActionEntry(REDUCE, 64);
   _actionMap[140][RB] = ActionEntry(REDUCE, 64);
   _actionMap[140][KSEP] = ActionEntry(REDUCE, 64);
   _actionMap[132][COLLATE] = ActionEntry(REDUCE, 14);
   _actionMap[132][ENDTOKEN] = ActionEntry(REDUCE, 14);
   _actionMap[133][KSEP] = ActionEntry(REDUCE, 35);
   _actionMap[133][RB] = ActionEntry(REDUCE, 35);
   _actionMap[134][KSEP] = ActionEntry(REDUCE, 33);
   _actionMap[134][RB] = ActionEntry(REDUCE, 33);
   _actionMap[135][CURRENTTIMESTAMP] = ActionEntry(SHIFT, 38);
   _actionMap[135][INTVAL] = ActionEntry(SHIFT, 41);
   _actionMap[135][MINUS] = ActionEntry(SHIFT, 40);
   _actionMap[135][STRINGVAL] = ActionEntry(SHIFT, 37);
   _actionMap[135][NULLTOKEN] = ActionEntry(SHIFT, 39);
   _jumpMap[135][Constant] = 139;
   _actionMap[136][RB] = ActionEntry(SHIFT, 140);
   _actionMap[137][KSEP] = ActionEntry(REDUCE, 56);
   _actionMap[137][RB] = ActionEntry(REDUCE, 56);
   _actionMap[138][NULLTOKEN] = ActionEntry(REDUCE, 49);
   _actionMap[138][NOT] = ActionEntry(REDUCE, 49);
   _actionMap[138][DEFAULT] = ActionEntry(REDUCE, 49);
   _actionMap[138][ON] = ActionEntry(REDUCE, 49);
   _actionMap[138][AUTOINCREMENT] = ActionEntry(REDUCE, 49);
   _actionMap[138][RB] = ActionEntry(REDUCE, 49);
   _actionMap[138][KSEP] = ActionEntry(REDUCE, 49);
   _actionMap[114][DEFAULT] = ActionEntry(REDUCE, 12);
   _actionMap[114][COLLATE] = ActionEntry(REDUCE, 12);
   _actionMap[114][ENDTOKEN] = ActionEntry(REDUCE, 12);
   _actionMap[115][ENDTOKEN] = ActionEntry(REDUCE, 16);
   _actionMap[116][IDENTIFIER] = ActionEntry(SHIFT, 132);
   _actionMap[117][AUTOINCREMENT] = ActionEntry(REDUCE, 10);
   _actionMap[117][DEFAULT] = ActionEntry(REDUCE, 10);
   _actionMap[117][COLLATE] = ActionEntry(REDUCE, 10);
   _actionMap[117][ENDTOKEN] = ActionEntry(REDUCE, 10);
   _actionMap[118][IDENTIFIER] = ActionEntry(SHIFT, 133);
   _actionMap[119][KSEP] = ActionEntry(REDUCE, 34);
   _actionMap[119][RB] = ActionEntry(REDUCE, 34);
   _actionMap[120][KSEP] = ActionEntry(REDUCE, 32);
   _actionMap[120][RB] = ActionEntry(REDUCE, 32);
   _actionMap[121][RB] = ActionEntry(SHIFT, 134);
   _actionMap[121][KSEP] = ActionEntry(SHIFT, 118);
   _actionMap[122][KSEP] = ActionEntry(REDUCE, 20);
}
void MySQLParser::loadParser1()
{
   _actionMap[122][RB] = ActionEntry(REDUCE, 20);
   _actionMap[123][AUTOINCREMENT] = ActionEntry(SHIFT, 124);
   _actionMap[123][KSEP] = ActionEntry(REDUCE, 29);
   _actionMap[123][RB] = ActionEntry(REDUCE, 29);
   _jumpMap[123][IncrementOpt] = 122;
   _actionMap[124][KSEP] = ActionEntry(REDUCE, 28);
   _actionMap[124][RB] = ActionEntry(REDUCE, 28);
   _actionMap[125][UPDATE] = ActionEntry(SHIFT, 135);
   _actionMap[126][ON] = ActionEntry(REDUCE, 25);
   _actionMap[126][AUTOINCREMENT] = ActionEntry(REDUCE, 25);
   _actionMap[126][RB] = ActionEntry(REDUCE, 25);
   _actionMap[126][KSEP] = ActionEntry(REDUCE, 25);
   _actionMap[127][INTVAL] = ActionEntry(SHIFT, 136);
   _actionMap[128][CURRENTTIMESTAMP] = ActionEntry(SHIFT, 38);
   _actionMap[128][INTVAL] = ActionEntry(SHIFT, 41);
   _actionMap[128][MINUS] = ActionEntry(SHIFT, 40);
   _actionMap[128][STRINGVAL] = ActionEntry(SHIFT, 37);
   _actionMap[128][NULLTOKEN] = ActionEntry(SHIFT, 39);
   _jumpMap[128][Constant] = 137;
   _actionMap[129][NULLTOKEN] = ActionEntry(REDUCE, 55);
   _actionMap[129][NOT] = ActionEntry(REDUCE, 55);
   _actionMap[129][DEFAULT] = ActionEntry(REDUCE, 55);
   _actionMap[129][ON] = ActionEntry(REDUCE, 55);
   _actionMap[129][AUTOINCREMENT] = ActionEntry(REDUCE, 55);
   _actionMap[129][RB] = ActionEntry(REDUCE, 55);
   _actionMap[129][KSEP] = ActionEntry(REDUCE, 55);
   _actionMap[130][UNSIGNED] = ActionEntry(REDUCE, 63);
   _actionMap[130][NULLTOKEN] = ActionEntry(REDUCE, 63);
   _actionMap[130][NOT] = ActionEntry(REDUCE, 63);
   _actionMap[130][DEFAULT] = ActionEntry(REDUCE, 63);
   _actionMap[130][ON] = ActionEntry(REDUCE, 63);
   _actionMap[130][AUTOINCREMENT] = ActionEntry(REDUCE, 63);
   _actionMap[130][RB] = ActionEntry(REDUCE, 63);
   _actionMap[130][KSEP] = ActionEntry(REDUCE, 63);
   _actionMap[131][COLLATE] = ActionEntry(SHIFT, 90);
   _actionMap[131][NULLTOKEN] = ActionEntry(REDUCE, 68);
   _actionMap[131][NOT] = ActionEntry(REDUCE, 68);
   _actionMap[131][DEFAULT] = ActionEntry(REDUCE, 68);
   _actionMap[131][ON] = ActionEntry(REDUCE, 68);
   _actionMap[131][AUTOINCREMENT] = ActionEntry(REDUCE, 68);
   _actionMap[131][RB] = ActionEntry(REDUCE, 68);
   _actionMap[131][KSEP] = ActionEntry(REDUCE, 68);
   _jumpMap[131][CollateOpt] = 138;
   _actionMap[93][INTVAL] = ActionEntry(SHIFT, 114);
   _actionMap[94][IDENTIFIER] = ActionEntry(SHIFT, 115);
   _actionMap[95][EQU] = ActionEntry(SHIFT, 116);
   _actionMap[96][IDENTIFIER] = ActionEntry(SHIFT, 117);
   _actionMap[97][RB] = ActionEntry(SHIFT, 119);
   _actionMap[97][KSEP] = ActionEntry(SHIFT, 118);
   _actionMap[98][KSEP] = ActionEntry(REDUCE, 36);
}
void MySQLParser::loadParser2()
{
   _actionMap[98][RB] = ActionEntry(REDUCE, 36);
   _actionMap[99][RB] = ActionEntry(SHIFT, 120);
   _actionMap[99][KSEP] = ActionEntry(SHIFT, 118);
   _actionMap[100][IDENTIFIER] = ActionEntry(SHIFT, 98);
   _jumpMap[100][KeyList] = 121;
   _actionMap[101][ON] = ActionEntry(SHIFT, 125);
   _actionMap[101][AUTOINCREMENT] = ActionEntry(REDUCE, 31);
   _actionMap[101][RB] = ActionEntry(REDUCE, 31);
   _actionMap[101][KSEP] = ActionEntry(REDUCE, 31);
   _jumpMap[101][OnUpdateOpt] = 123;
   _jumpMap[101][IncrementOpt] = 122;
   _actionMap[102][ON] = ActionEntry(REDUCE, 26);
   _actionMap[102][AUTOINCREMENT] = ActionEntry(REDUCE, 26);
   _actionMap[102][RB] = ActionEntry(REDUCE, 26);
   _actionMap[102][KSEP] = ActionEntry(REDUCE, 26);
   _actionMap[103][CURRENTTIMESTAMP] = ActionEntry(SHIFT, 38);
   _actionMap[103][INTVAL] = ActionEntry(SHIFT, 41);
   _actionMap[103][MINUS] = ActionEntry(SHIFT, 40);
   _actionMap[103][STRINGVAL] = ActionEntry(SHIFT, 37);
   _actionMap[103][NULLTOKEN] = ActionEntry(SHIFT, 39);
   _jumpMap[103][Constant] = 126;
   _actionMap[104][DEFAULT] = ActionEntry(REDUCE, 22);
   _actionMap[104][ON] = ActionEntry(REDUCE, 22);
   _actionMap[104][AUTOINCREMENT] = ActionEntry(REDUCE, 22);
   _actionMap[104][RB] = ActionEntry(REDUCE, 22);
   _actionMap[104][KSEP] = ActionEntry(REDUCE, 22);
   _actionMap[105][NULLTOKEN] = ActionEntry(REDUCE, 48);
   _actionMap[105][NOT] = ActionEntry(REDUCE, 48);
   _actionMap[105][DEFAULT] = ActionEntry(REDUCE, 48);
   _actionMap[105][ON] = ActionEntry(REDUCE, 48);
   _actionMap[105][AUTOINCREMENT] = ActionEntry(REDUCE, 48);
   _actionMap[105][RB] = ActionEntry(REDUCE, 48);
   _actionMap[105][KSEP] = ActionEntry(REDUCE, 48);
   _actionMap[106][NULLTOKEN] = ActionEntry(REDUCE, 65);
   _actionMap[106][NOT] = ActionEntry(REDUCE, 65);
   _actionMap[106][DEFAULT] = ActionEntry(REDUCE, 65);
   _actionMap[106][ON] = ActionEntry(REDUCE, 65);
   _actionMap[106][AUTOINCREMENT] = ActionEntry(REDUCE, 65);
   _actionMap[106][RB] = ActionEntry(REDUCE, 65);
   _actionMap[106][KSEP] = ActionEntry(REDUCE, 65);
   _actionMap[107][KSEP] = ActionEntry(SHIFT, 127);
   _actionMap[108][RB] = ActionEntry(SHIFT, 129);
   _actionMap[108][KSEP] = ActionEntry(SHIFT, 128);
   _actionMap[109][KSEP] = ActionEntry(REDUCE, 57);
   _actionMap[109][RB] = ActionEntry(REDUCE, 57);
   _actionMap[110][NULLTOKEN] = ActionEntry(REDUCE, 47);
   _actionMap[110][NOT] = ActionEntry(REDUCE, 47);
   _actionMap[110][DEFAULT] = ActionEntry(REDUCE, 47);
   _actionMap[110][ON] = ActionEntry(REDUCE, 47);
   _actionMap[110][AUTOINCREMENT] = ActionEntry(REDUCE, 47);
}
void MySQLParser::loadParser3()
{
   _actionMap[110][RB] = ActionEntry(REDUCE, 47);
   _actionMap[110][KSEP] = ActionEntry(REDUCE, 47);
   _actionMap[111][RB] = ActionEntry(SHIFT, 130);
   _actionMap[112][NULLTOKEN] = ActionEntry(REDUCE, 67);
   _actionMap[112][NOT] = ActionEntry(REDUCE, 67);
   _actionMap[112][DEFAULT] = ActionEntry(REDUCE, 67);
   _actionMap[112][ON] = ActionEntry(REDUCE, 67);
   _actionMap[112][AUTOINCREMENT] = ActionEntry(REDUCE, 67);
   _actionMap[112][RB] = ActionEntry(REDUCE, 67);
   _actionMap[112][KSEP] = ActionEntry(REDUCE, 67);
   _actionMap[113][RB] = ActionEntry(SHIFT, 131);
   _actionMap[67][KSEP] = ActionEntry(REDUCE, 43);
   _actionMap[67][RB] = ActionEntry(REDUCE, 43);
   _actionMap[68][KSEP] = ActionEntry(REDUCE, 18);
   _actionMap[68][RB] = ActionEntry(REDUCE, 18);
   _actionMap[69][AUTOINCREMENT] = ActionEntry(SHIFT, 73);
   _actionMap[69][DEFAULT] = ActionEntry(REDUCE, 13);
   _actionMap[69][COLLATE] = ActionEntry(REDUCE, 13);
   _actionMap[69][ENDTOKEN] = ActionEntry(REDUCE, 13);
   _jumpMap[69][TableCollateOpt] = 72;
   _jumpMap[69][TableCharsetOpt] = 71;
   _jumpMap[69][AutoIncrementOpt] = 70;
   _actionMap[70][DEFAULT] = ActionEntry(SHIFT, 75);
   _actionMap[70][COLLATE] = ActionEntry(REDUCE, 15);
   _actionMap[70][ENDTOKEN] = ActionEntry(REDUCE, 15);
   _jumpMap[70][TableCollateOpt] = 72;
   _jumpMap[70][TableCharsetOpt] = 71;
   _actionMap[71][COLLATE] = ActionEntry(SHIFT, 74);
   _actionMap[71][ENDTOKEN] = ActionEntry(REDUCE, 17);
   _jumpMap[71][TableCollateOpt] = 72;
   _actionMap[72][ENDTOKEN] = ActionEntry(REDUCE, 6);
   _actionMap[73][EQU] = ActionEntry(SHIFT, 93);
   _actionMap[74][EQU] = ActionEntry(SHIFT, 94);
   _actionMap[75][CHARSET] = ActionEntry(SHIFT, 95);
   _actionMap[76][EQU] = ActionEntry(SHIFT, 96);
   _actionMap[77][IDENTIFIER] = ActionEntry(SHIFT, 98);
   _jumpMap[77][KeyList] = 97;
   _actionMap[78][IDENTIFIER] = ActionEntry(SHIFT, 98);
   _jumpMap[78][KeyList] = 99;
   _actionMap[79][LB] = ActionEntry(SHIFT, 100);
   _actionMap[80][KSEP] = ActionEntry(REDUCE, 27);
   _actionMap[80][RB] = ActionEntry(REDUCE, 27);
   _actionMap[80][AUTOINCREMENT] = ActionEntry(REDUCE, 27);
   _actionMap[80][ON] = ActionEntry(REDUCE, 27);
   _actionMap[80][DEFAULT] = ActionEntry(SHIFT, 103);
   _jumpMap[80][DefaultDefOpt] = 102;
   _jumpMap[80][DefaultOpt] = 101;
   _actionMap[81][DEFAULT] = ActionEntry(REDUCE, 23);
   _actionMap[81][ON] = ActionEntry(REDUCE, 23);
   _actionMap[81][AUTOINCREMENT] = ActionEntry(REDUCE, 23);
}
void MySQLParser::loadParser4()
{
   _actionMap[81][RB] = ActionEntry(REDUCE, 23);
   _actionMap[81][KSEP] = ActionEntry(REDUCE, 23);
   _actionMap[82][NULLTOKEN] = ActionEntry(SHIFT, 104);
   _actionMap[83][DEFAULT] = ActionEntry(REDUCE, 21);
   _actionMap[83][ON] = ActionEntry(REDUCE, 21);
   _actionMap[83][AUTOINCREMENT] = ActionEntry(REDUCE, 21);
   _actionMap[83][RB] = ActionEntry(REDUCE, 21);
   _actionMap[83][KSEP] = ActionEntry(REDUCE, 21);
   _actionMap[84][UNSIGNED] = ActionEntry(SHIFT, 106);
   _actionMap[84][NULLTOKEN] = ActionEntry(REDUCE, 66);
   _actionMap[84][NOT] = ActionEntry(REDUCE, 66);
   _actionMap[84][DEFAULT] = ActionEntry(REDUCE, 66);
   _actionMap[84][ON] = ActionEntry(REDUCE, 66);
   _actionMap[84][AUTOINCREMENT] = ActionEntry(REDUCE, 66);
   _actionMap[84][RB] = ActionEntry(REDUCE, 66);
   _actionMap[84][KSEP] = ActionEntry(REDUCE, 66);
   _jumpMap[84][UnsignedOpt] = 105;
   _actionMap[85][INTVAL] = ActionEntry(SHIFT, 107);
   _actionMap[86][CURRENTTIMESTAMP] = ActionEntry(SHIFT, 38);
   _actionMap[86][INTVAL] = ActionEntry(SHIFT, 41);
   _actionMap[86][MINUS] = ActionEntry(SHIFT, 40);
   _actionMap[86][STRINGVAL] = ActionEntry(SHIFT, 37);
   _actionMap[86][NULLTOKEN] = ActionEntry(SHIFT, 39);
   _jumpMap[86][Constant] = 109;
   _jumpMap[86][ConstList] = 108;
   _actionMap[87][UNSIGNED] = ActionEntry(SHIFT, 106);
   _actionMap[87][NULLTOKEN] = ActionEntry(REDUCE, 66);
   _actionMap[87][NOT] = ActionEntry(REDUCE, 66);
   _actionMap[87][DEFAULT] = ActionEntry(REDUCE, 66);
   _actionMap[87][ON] = ActionEntry(REDUCE, 66);
   _actionMap[87][AUTOINCREMENT] = ActionEntry(REDUCE, 66);
   _actionMap[87][RB] = ActionEntry(REDUCE, 66);
   _actionMap[87][KSEP] = ActionEntry(REDUCE, 66);
   _jumpMap[87][UnsignedOpt] = 110;
   _actionMap[88][INTVAL] = ActionEntry(SHIFT, 111);
   _actionMap[89][NULLTOKEN] = ActionEntry(REDUCE, 53);
   _actionMap[89][NOT] = ActionEntry(REDUCE, 53);
   _actionMap[89][DEFAULT] = ActionEntry(REDUCE, 53);
   _actionMap[89][ON] = ActionEntry(REDUCE, 53);
   _actionMap[89][AUTOINCREMENT] = ActionEntry(REDUCE, 53);
   _actionMap[89][RB] = ActionEntry(REDUCE, 53);
   _actionMap[89][KSEP] = ActionEntry(REDUCE, 53);
   _actionMap[90][IDENTIFIER] = ActionEntry(SHIFT, 112);
   _actionMap[91][NULLTOKEN] = ActionEntry(REDUCE, 54);
   _actionMap[91][NOT] = ActionEntry(REDUCE, 54);
   _actionMap[91][DEFAULT] = ActionEntry(REDUCE, 54);
   _actionMap[91][ON] = ActionEntry(REDUCE, 54);
   _actionMap[91][AUTOINCREMENT] = ActionEntry(REDUCE, 54);
   _actionMap[91][RB] = ActionEntry(REDUCE, 54);
   _actionMap[91][KSEP] = ActionEntry(REDUCE, 54);
}
void MySQLParser::loadParser5()
{
   _actionMap[92][INTVAL] = ActionEntry(SHIFT, 113);
   _actionMap[48][ENDTOKEN] = ActionEntry(REDUCE, 40);
   _actionMap[48][KSEP] = ActionEntry(REDUCE, 40);
   _actionMap[49][CURRENTTIMESTAMP] = ActionEntry(SHIFT, 38);
   _actionMap[49][INTVAL] = ActionEntry(SHIFT, 41);
   _actionMap[49][MINUS] = ActionEntry(SHIFT, 40);
   _actionMap[49][STRINGVAL] = ActionEntry(SHIFT, 37);
   _actionMap[49][NULLTOKEN] = ActionEntry(SHIFT, 39);
   _jumpMap[49][Constant] = 67;
   _actionMap[50][ENDTOKEN] = ActionEntry(REDUCE, 42);
   _actionMap[50][KSEP] = ActionEntry(REDUCE, 42);
   _actionMap[51][ON] = ActionEntry(REDUCE, 60);
   _actionMap[51][AUTOINCREMENT] = ActionEntry(REDUCE, 60);
   _actionMap[51][RB] = ActionEntry(REDUCE, 60);
   _actionMap[51][KSEP] = ActionEntry(REDUCE, 60);
   _actionMap[52][IDENTIFIER] = ActionEntry(SHIFT, 47);
   _actionMap[52][PRIMARY] = ActionEntry(SHIFT, 45);
   _actionMap[52][UNIQUE] = ActionEntry(SHIFT, 46);
   _actionMap[52][KEY] = ActionEntry(SHIFT, 44);
   _jumpMap[52][ColumnDesc] = 68;
   _actionMap[53][ENGINE] = ActionEntry(SHIFT, 76);
   _actionMap[53][AUTOINCREMENT] = ActionEntry(REDUCE, 11);
   _actionMap[53][DEFAULT] = ActionEntry(REDUCE, 11);
   _actionMap[53][COLLATE] = ActionEntry(REDUCE, 11);
   _actionMap[53][ENDTOKEN] = ActionEntry(REDUCE, 11);
   _jumpMap[53][TableCollateOpt] = 72;
   _jumpMap[53][TableCharsetOpt] = 71;
   _jumpMap[53][AutoIncrementOpt] = 70;
   _jumpMap[53][EngineOpt] = 69;
   _actionMap[54][LB] = ActionEntry(SHIFT, 77);
   _actionMap[55][LB] = ActionEntry(SHIFT, 78);
   _actionMap[56][IDENTIFIER] = ActionEntry(SHIFT, 79);
   _actionMap[57][KSEP] = ActionEntry(REDUCE, 24);
   _actionMap[57][RB] = ActionEntry(REDUCE, 24);
   _actionMap[57][AUTOINCREMENT] = ActionEntry(REDUCE, 24);
   _actionMap[57][ON] = ActionEntry(REDUCE, 24);
   _actionMap[57][DEFAULT] = ActionEntry(REDUCE, 24);
   _actionMap[57][NULLTOKEN] = ActionEntry(SHIFT, 83);
   _actionMap[57][NOT] = ActionEntry(SHIFT, 82);
   _jumpMap[57][DefaultNullOpt] = 81;
   _jumpMap[57][NullOpt] = 80;
   _actionMap[58][NULLTOKEN] = ActionEntry(REDUCE, 51);
   _actionMap[58][NOT] = ActionEntry(REDUCE, 51);
   _actionMap[58][DEFAULT] = ActionEntry(REDUCE, 51);
   _actionMap[58][ON] = ActionEntry(REDUCE, 51);
   _actionMap[58][AUTOINCREMENT] = ActionEntry(REDUCE, 51);
   _actionMap[58][RB] = ActionEntry(REDUCE, 51);
   _actionMap[58][KSEP] = ActionEntry(REDUCE, 51);
   _actionMap[59][LB] = ActionEntry(SHIFT, 85);
   _jumpMap[59][DecimalDimOpt] = 84;
}
void MySQLParser::loadParser6()
{
   _actionMap[60][LB] = ActionEntry(SHIFT, 86);
   _actionMap[61][LB] = ActionEntry(SHIFT, 88);
   _jumpMap[61][DimOpt] = 87;
   _actionMap[62][NULLTOKEN] = ActionEntry(REDUCE, 52);
   _actionMap[62][NOT] = ActionEntry(REDUCE, 52);
   _actionMap[62][DEFAULT] = ActionEntry(REDUCE, 52);
   _actionMap[62][ON] = ActionEntry(REDUCE, 52);
   _actionMap[62][AUTOINCREMENT] = ActionEntry(REDUCE, 52);
   _actionMap[62][RB] = ActionEntry(REDUCE, 52);
   _actionMap[62][KSEP] = ActionEntry(REDUCE, 52);
   _actionMap[63][COLLATE] = ActionEntry(SHIFT, 90);
   _actionMap[63][NULLTOKEN] = ActionEntry(REDUCE, 68);
   _actionMap[63][NOT] = ActionEntry(REDUCE, 68);
   _actionMap[63][DEFAULT] = ActionEntry(REDUCE, 68);
   _actionMap[63][ON] = ActionEntry(REDUCE, 68);
   _actionMap[63][AUTOINCREMENT] = ActionEntry(REDUCE, 68);
   _actionMap[63][RB] = ActionEntry(REDUCE, 68);
   _actionMap[63][KSEP] = ActionEntry(REDUCE, 68);
   _jumpMap[63][CollateOpt] = 89;
   _actionMap[64][COLLATE] = ActionEntry(SHIFT, 90);
   _actionMap[64][NULLTOKEN] = ActionEntry(REDUCE, 68);
   _actionMap[64][NOT] = ActionEntry(REDUCE, 68);
   _actionMap[64][DEFAULT] = ActionEntry(REDUCE, 68);
   _actionMap[64][ON] = ActionEntry(REDUCE, 68);
   _actionMap[64][AUTOINCREMENT] = ActionEntry(REDUCE, 68);
   _actionMap[64][RB] = ActionEntry(REDUCE, 68);
   _actionMap[64][KSEP] = ActionEntry(REDUCE, 68);
   _jumpMap[64][CollateOpt] = 91;
   _actionMap[65][NULLTOKEN] = ActionEntry(REDUCE, 50);
   _actionMap[65][NOT] = ActionEntry(REDUCE, 50);
   _actionMap[65][DEFAULT] = ActionEntry(REDUCE, 50);
   _actionMap[65][ON] = ActionEntry(REDUCE, 50);
   _actionMap[65][AUTOINCREMENT] = ActionEntry(REDUCE, 50);
   _actionMap[65][RB] = ActionEntry(REDUCE, 50);
   _actionMap[65][KSEP] = ActionEntry(REDUCE, 50);
   _actionMap[66][LB] = ActionEntry(SHIFT, 92);
   _actionMap[34][LB] = ActionEntry(SHIFT, 29);
   _jumpMap[34][InsertValueSpec] = 48;
   _actionMap[35][RB] = ActionEntry(SHIFT, 50);
   _actionMap[35][KSEP] = ActionEntry(SHIFT, 49);
   _actionMap[36][KSEP] = ActionEntry(REDUCE, 44);
   _actionMap[36][RB] = ActionEntry(REDUCE, 44);
   _actionMap[37][ON] = ActionEntry(REDUCE, 61);
   _actionMap[37][AUTOINCREMENT] = ActionEntry(REDUCE, 61);
   _actionMap[37][KSEP] = ActionEntry(REDUCE, 61);
   _actionMap[37][RB] = ActionEntry(REDUCE, 61);
   _actionMap[38][ON] = ActionEntry(REDUCE, 58);
   _actionMap[38][AUTOINCREMENT] = ActionEntry(REDUCE, 58);
   _actionMap[38][KSEP] = ActionEntry(REDUCE, 58);
   _actionMap[38][RB] = ActionEntry(REDUCE, 58);
}
void MySQLParser::loadParser7()
{
   _actionMap[39][ON] = ActionEntry(REDUCE, 62);
   _actionMap[39][AUTOINCREMENT] = ActionEntry(REDUCE, 62);
   _actionMap[39][RB] = ActionEntry(REDUCE, 62);
   _actionMap[39][KSEP] = ActionEntry(REDUCE, 62);
   _actionMap[40][INTVAL] = ActionEntry(SHIFT, 51);
   _actionMap[41][ON] = ActionEntry(REDUCE, 59);
   _actionMap[41][AUTOINCREMENT] = ActionEntry(REDUCE, 59);
   _actionMap[41][RB] = ActionEntry(REDUCE, 59);
   _actionMap[41][KSEP] = ActionEntry(REDUCE, 59);
   _actionMap[42][RB] = ActionEntry(SHIFT, 53);
   _actionMap[42][KSEP] = ActionEntry(SHIFT, 52);
   _actionMap[43][KSEP] = ActionEntry(REDUCE, 19);
   _actionMap[43][RB] = ActionEntry(REDUCE, 19);
   _actionMap[44][IDENTIFIER] = ActionEntry(SHIFT, 54);
   _actionMap[45][KEY] = ActionEntry(SHIFT, 55);
   _actionMap[46][KEY] = ActionEntry(SHIFT, 56);
   _actionMap[47][INT] = ActionEntry(SHIFT, 61);
   _actionMap[47][DECIMAL] = ActionEntry(SHIFT, 59);
   _actionMap[47][VARCHAR] = ActionEntry(SHIFT, 66);
   _actionMap[47][TIMESTAMP] = ActionEntry(SHIFT, 65);
   _actionMap[47][DATETIME] = ActionEntry(SHIFT, 58);
   _actionMap[47][LONGBLOB] = ActionEntry(SHIFT, 62);
   _actionMap[47][MEDIUMTEXT] = ActionEntry(SHIFT, 63);
   _actionMap[47][TEXT] = ActionEntry(SHIFT, 64);
   _actionMap[47][ENUM] = ActionEntry(SHIFT, 60);
   _jumpMap[47][DataTypeProd] = 57;
   _actionMap[27][KSEP] = ActionEntry(SHIFT, 34);
   _actionMap[27][ENDTOKEN] = ActionEntry(REDUCE, 39);
   _actionMap[28][ENDTOKEN] = ActionEntry(REDUCE, 41);
   _actionMap[28][KSEP] = ActionEntry(REDUCE, 41);
   _actionMap[29][CURRENTTIMESTAMP] = ActionEntry(SHIFT, 38);
   _actionMap[29][INTVAL] = ActionEntry(SHIFT, 41);
   _actionMap[29][MINUS] = ActionEntry(SHIFT, 40);
   _actionMap[29][STRINGVAL] = ActionEntry(SHIFT, 37);
   _actionMap[29][NULLTOKEN] = ActionEntry(SHIFT, 39);
   _jumpMap[29][Constant] = 36;
   _jumpMap[29][InsertValueList] = 35;
   _actionMap[30][IDENTIFIER] = ActionEntry(SHIFT, 47);
   _actionMap[30][PRIMARY] = ActionEntry(SHIFT, 45);
   _actionMap[30][UNIQUE] = ActionEntry(SHIFT, 46);
   _actionMap[30][KEY] = ActionEntry(SHIFT, 44);
   _jumpMap[30][ColumnDesc] = 43;
   _jumpMap[30][ColumnList] = 42;
   _actionMap[31][IDENTIFIER] = ActionEntry(REDUCE, 9);
   _actionMap[32][ENDTOKEN] = ActionEntry(REDUCE, 37);
   _actionMap[33][ENDTOKEN] = ActionEntry(REDUCE, 2);
   _actionMap[22][LB] = ActionEntry(SHIFT, 29);
   _jumpMap[22][InsertValueSpec] = 28;
   _jumpMap[22][InsertValueSpecList] = 27;
   _actionMap[23][LB] = ActionEntry(SHIFT, 30);
}
void MySQLParser::loadParser8()
{
   _actionMap[24][EXISTS] = ActionEntry(SHIFT, 31);
   _actionMap[25][WRITE] = ActionEntry(SHIFT, 32);
   _actionMap[26][IDENTIFIER] = ActionEntry(SHIFT, 33);
   _actionMap[13][ENDTOKEN] = ActionEntry(REDUCE, 7);
   _actionMap[14][VALUES] = ActionEntry(REDUCE, 46);
   _actionMap[14][ENDTOKEN] = ActionEntry(REDUCE, 46);
   _actionMap[14][LB] = ActionEntry(REDUCE, 46);
   _actionMap[15][VALUES] = ActionEntry(SHIFT, 22);
   _actionMap[16][IDENTIFIER] = ActionEntry(SHIFT, 14);
   _jumpMap[16][Table] = 23;
   _actionMap[17][IF] = ActionEntry(SHIFT, 24);
   _actionMap[17][IDENTIFIER] = ActionEntry(REDUCE, 8);
   _actionMap[18][IDENTIFIER] = ActionEntry(REDUCE, 45);
   _actionMap[19][IDENTIFIER] = ActionEntry(SHIFT, 25);
   _actionMap[20][EQU] = ActionEntry(SHIFT, 26);
   _actionMap[21][ENDTOKEN] = ActionEntry(REDUCE, 38);
   _actionMap[1][ENDTOKEN] = ActionEntry(ACCEPT, 0);
   _actionMap[2][IDENTIFIER] = ActionEntry(SHIFT, 14);
   _jumpMap[2][Table] = 13;
   _actionMap[3][ENDTOKEN] = ActionEntry(REDUCE, 4);
   _actionMap[4][ENDTOKEN] = ActionEntry(REDUCE, 5);
   _actionMap[5][ENDTOKEN] = ActionEntry(REDUCE, 3);
   _actionMap[6][IDENTIFIER] = ActionEntry(SHIFT, 14);
   _jumpMap[6][Table] = 15;
   _actionMap[7][TABLE] = ActionEntry(SHIFT, 16);
   _actionMap[8][TABLE] = ActionEntry(SHIFT, 17);
   _actionMap[9][INTO] = ActionEntry(SHIFT, 18);
   _actionMap[10][TABLES] = ActionEntry(SHIFT, 19);
   _actionMap[11][IDENTIFIER] = ActionEntry(SHIFT, 20);
   _actionMap[12][TABLES] = ActionEntry(SHIFT, 21);
   _actionMap[0][INSERT] = ActionEntry(SHIFT, 9);
   _actionMap[0][DROP] = ActionEntry(SHIFT, 8);
   _actionMap[0][UNLOCK] = ActionEntry(SHIFT, 12);
   _actionMap[0][LOCK] = ActionEntry(SHIFT, 10);
   _actionMap[0][ENDTOKEN] = ActionEntry(REDUCE, 1);
   _actionMap[0][SET] = ActionEntry(SHIFT, 11);
   _actionMap[0][CREATE] = ActionEntry(SHIFT, 7);
   _jumpMap[0][InsertPrefix] = 6;
   _jumpMap[0][InsertStatement] = 5;
   _jumpMap[0][UnlockStatement] = 4;
   _jumpMap[0][LockStatement] = 3;
   _jumpMap[0][DropOpt] = 2;
   _jumpMap[0][Statement] = 1;
}
void MySQLParser::loadParser9()
{
   _prodInfo.Insert(ProdEntry(68, CollateOpt, 0));
   _prodInfo.Insert(ProdEntry(67, CollateOpt, 2));
   _prodInfo.Insert(ProdEntry(66, UnsignedOpt, 0));
   _prodInfo.Insert(ProdEntry(65, UnsignedOpt, 1));
   _prodInfo.Insert(ProdEntry(64, DecimalDimOpt, 5));
   _prodInfo.Insert(ProdEntry(63, DimOpt, 3));
   _prodInfo.Insert(ProdEntry(62, Constant, 1));
   _prodInfo.Insert(ProdEntry(61, Constant, 1));
   _prodInfo.Insert(ProdEntry(60, Constant, 2));
   _prodInfo.Insert(ProdEntry(59, Constant, 1));
   _prodInfo.Insert(ProdEntry(58, Constant, 1));
   _prodInfo.Insert(ProdEntry(57, ConstList, 1));
   _prodInfo.Insert(ProdEntry(56, ConstList, 3));
   _prodInfo.Insert(ProdEntry(55, DataTypeProd, 4));
   _prodInfo.Insert(ProdEntry(54, DataTypeProd, 2));
   _prodInfo.Insert(ProdEntry(53, DataTypeProd, 2));
   _prodInfo.Insert(ProdEntry(52, DataTypeProd, 1));
   _prodInfo.Insert(ProdEntry(51, DataTypeProd, 1));
   _prodInfo.Insert(ProdEntry(50, DataTypeProd, 1));
   _prodInfo.Insert(ProdEntry(49, DataTypeProd, 5));
   _prodInfo.Insert(ProdEntry(48, DataTypeProd, 3));
   _prodInfo.Insert(ProdEntry(47, DataTypeProd, 3));
   _prodInfo.Insert(ProdEntry(46, Table, 1));
   _prodInfo.Insert(ProdEntry(45, InsertPrefix, 2));
   _prodInfo.Insert(ProdEntry(44, InsertValueList, 1));
   _prodInfo.Insert(ProdEntry(43, InsertValueList, 3));
   _prodInfo.Insert(ProdEntry(42, InsertValueSpec, 3));
   _prodInfo.Insert(ProdEntry(41, InsertValueSpecList, 1));
   _prodInfo.Insert(ProdEntry(40, InsertValueSpecList, 3));
   _prodInfo.Insert(ProdEntry(39, InsertStatement, 4));
   _prodInfo.Insert(ProdEntry(38, UnlockStatement, 2));
   _prodInfo.Insert(ProdEntry(37, LockStatement, 4));
   _prodInfo.Insert(ProdEntry(36, KeyList, 1));
   _prodInfo.Insert(ProdEntry(35, KeyList, 3));
   _prodInfo.Insert(ProdEntry(34, ColumnDesc, 5));
   _prodInfo.Insert(ProdEntry(33, ColumnDesc, 6));
   _prodInfo.Insert(ProdEntry(32, ColumnDesc, 5));
   _prodInfo.Insert(ProdEntry(31, OnUpdateOpt, 0));
   _prodInfo.Insert(ProdEntry(30, OnUpdateOpt, 3));
   _prodInfo.Insert(ProdEntry(29, IncrementOpt, 0));
   _prodInfo.Insert(ProdEntry(28, IncrementOpt, 1));
   _prodInfo.Insert(ProdEntry(27, DefaultDefOpt, 0));
   _prodInfo.Insert(ProdEntry(26, DefaultOpt, 1));
   _prodInfo.Insert(ProdEntry(25, DefaultOpt, 2));
   _prodInfo.Insert(ProdEntry(24, DefaultNullOpt, 0));
   _prodInfo.Insert(ProdEntry(23, NullOpt, 1));
   _prodInfo.Insert(ProdEntry(22, NullOpt, 2));
   _prodInfo.Insert(ProdEntry(21, NullOpt, 1));
   _prodInfo.Insert(ProdEntry(20, ColumnDesc, 6));
   _prodInfo.Insert(ProdEntry(19, ColumnList, 1));
   _prodInfo.Insert(ProdEntry(18, ColumnList, 3));
   _prodInfo.Insert(ProdEntry(17, TableCollateOpt, 0));
   _prodInfo.Insert(ProdEntry(16, TableCollateOpt, 3));
   _prodInfo.Insert(ProdEntry(15, TableCharsetOpt, 0));
   _prodInfo.Insert(ProdEntry(14, TableCharsetOpt, 4));
   _prodInfo.Insert(ProdEntry(13, AutoIncrementOpt, 0));
   _prodInfo.Insert(ProdEntry(12, AutoIncrementOpt, 3));
   _prodInfo.Insert(ProdEntry(11, EngineOpt, 0));
   _prodInfo.Insert(ProdEntry(10, EngineOpt, 3));
   _prodInfo.Insert(ProdEntry(9, DropOpt, 4));
   _prodInfo.Insert(ProdEntry(8, DropOpt, 2));
   _prodInfo.Insert(ProdEntry(7, Statement, 2));
   _prodInfo.Insert(ProdEntry(6, Statement, 10));
   _prodInfo.Insert(ProdEntry(5, Statement, 1));
   _prodInfo.Insert(ProdEntry(4, Statement, 1));
   _prodInfo.Insert(ProdEntry(3, Statement, 1));
   _prodInfo.Insert(ProdEntry(2, Statement, 4));
   _prodInfo.Insert(ProdEntry(1, Statement, 0));
   _prodInfo.Insert(ProdEntry(0, Start, 1));
}

MySQLParser::MySQLParser()
{
   loadScanner();
   for ( int i=0; i < 141; i++)
   {
      int j;
      for ( j = 0; j < 53; j++)
         _actionMap[i][j] = ActionEntry();
      for ( j = 0; j < 32; j++)
         _jumpMap[i][j] = -1;
   }
   loadParser0();
   loadParser1();
   loadParser2();
   loadParser3();
   loadParser4();
   loadParser5();
   loadParser6();
   loadParser7();
   loadParser8();
   loadParser9();
   _isReserved = false;
}

MySQLParser::~MySQLParser()
{
}

void MySQLParser::parse()
{
   StackT<StackEntry> s;
   StackEntry se(NONE, 0, 0);
   s.Push(se);
   _isReserved = false;
   if ( shiftToken() == false )
   {
      Chain msg = "Parse error at token <" + Chain(_tokenVal) + ">.";
      throw Exception(EXLOC, msg);
   }
   while ( true )
   {
      Action a;
      int num;
      if ( getAction(s.getTop()->getState(), _token, a, num) )
      {
         switch (a)
         {
            case SHIFT:
            {
               StackEntry se(TOKEN, _token, num, _tokenVal);
               s.Push(se);
               if ( shiftToken() == false )
               {
                  Chain msg = "Parse error at token <" + Chain(_tokenVal) + ">.";
                  throw Exception(EXLOC, msg);
               }
               break;
            }
            case REDUCE:
            {
               _tokenList.Empty();
               ProdEntry* pPE = _prodInfo.Find(num);
               for (int i=0; i<pPE->getNumSymbol();i++)
               {
                  StackEntry se;
                  s.Pop(se);
                  if (se.getSymbol() == TOKEN)
                     _tokenList.Insert(se.getTval());
               }
               int fstate;
               if (getJump(s.getTop()->getState(), pPE->getProd(), fstate))
               {
                  StackEntry se(PROD, pPE->getId(), fstate, _tokenVal);
                  s.Push(se);
               }
               else
               {
                  Chain msg = "Cannot reduce after token <" + Chain(_tokenVal) + ">.";
                  throw Exception(EXLOC, msg);
               }
               switch (num)
               {
                  case 65:
                     storeUnsignedType();
                     break;
                  case 64:
                     storeDecimalDim();
                     break;
                  case 63:
                     storeDim();
                     break;
                  case 62:
                     storeNullValue();
                     break;
                  case 61:
                     storeVarcharValue();
                     break;
                  case 60:
                     storeNegIntValue();
                     break;
                  case 59:
                     storeIntValue();
                     break;
                  case 58:
                     storeCurrentTimestampValue();
                     break;
                  case 55:
                     storeEnumType();
                     break;
                  case 54:
                     storeMediumTextType();
                     break;
                  case 53:
                     storeMediumTextType();
                     break;
                  case 51:
                     storeDatetimeType();
                     break;
                  case 50:
                     storeTimestampType();
                     break;
                  case 49:
                     storeVarcharType();
                     break;
                  case 48:
                     storeDecimalType();
                     break;
                  case 47:
                     storeIntType();
                     break;
                  case 46:
                     storeTable();
                     break;
                  case 45:
                     insertPreAction();
                     break;
                  case 44:
                     insertConstValue();
                     break;
                  case 43:
                     insertConstValue();
                     break;
                  case 42:
                     execInsert();
                     break;
                  case 39:
                     insertPostAction();
                     break;
                  case 36:
                     storeKeyColumn();
                     break;
                  case 35:
                     storeKeyColumn();
                     break;
                  case 34:
                     storeKey();
                     break;
                  case 33:
                     storeUniqueKey();
                     break;
                  case 32:
                     storePrimaryKey();
                     break;
                  case 26:
                     storeDefaultNullOpt();
                     break;
                  case 25:
                     storeDefaultOpt();
                     break;
                  case 23:
                     storeNullOpt();
                     break;
                  case 22:
                     storeNotNullOpt();
                     break;
                  case 21:
                     storeNullOpt();
                     break;
                  case 20:
                     storeAttrColumn();
                     break;
                  case 9:
                     dropOpt2();
                     break;
                  case 8:
                     dropOpt1();
                     break;
                  case 7:
                     execDrop();
                     break;
                  case 6:
                     execCreate();
                     break;
               }
               break;
            }
            case ACCEPT:
            {
               return;
            }
            default:
               break;
         }
      }
      else
      {
         Chain msg = "Parse error at token <" + Chain(_tokenVal) + ">.";
         throw Exception(EXLOC, msg);
      }
   }
}


bool MySQLParser::getAction(int state, MySQLParser::Token token, MySQLParser::Action& a, int& num)
{
    if (_actionMap[state][token].getAction() != NULLACTION )
    {
	a = _actionMap[state][token].getAction();
	num = _actionMap[state][token].getNum();
	return true;
    }
    else
    {
	return false;
    }
}

bool MySQLParser::getJump(int state, Production prod, int& fstate)
{
    if ( _jumpMap[state][prod] > 0 )
    {
       fstate = _jumpMap[state][prod];
	    return true;
    }
    else
    {
	    return false;
    }
}

bool MySQLParser::isSepSign(char c)
{
   if (c == ';') return true;
   if (c == ',') return true;
   if (c == '=') return true;
   if (c == '<') return true;
   if (c == '>') return true;
   if (c == ')') return true;
   if (c == '(') return true;
   if (c == '[') return true;
   if (c == ']') return true;
   if (c == '+') return true;
   if (c == '-') return true;
   if (c == '|') return true;
   return false;
}
bool MySQLParser::isSepIgnore(char c)
{
   if (c == '\t') return true;
   if (c == ' ') return true;
   if (c == '\n') return true;
   if (c == '\r') return true;
   return false;
}
bool MySQLParser::shiftToken()
{
   unsigned long i=0;
   char c;
   while ( isSepIgnore(c = nextChar()) && ! _isReserved );
   if ( _isReserved )
   {
      _token = _reservedToken;
      _isReserved = false;
      return true;
   }
   if (c == 0)
   {
      _token = ENDTOKEN;
      return true;
   }
   if (isSepSign(c))
   {
      _tokenVal[i]=c;
       i++;
   }
   else
   {
      while (c && ! isSepIgnore(c) && ! ( isSepSign(c) && i>0 ) )
      {
         _tokenVal[i]=c;
         i++;
         c = nextChar();
      }
      if (isSepSign(c)) backChar();
   }
   _tokenVal[i]=0;
   Scanner* pS = _scannerList.First();
   while (pS)
   {
      if (pS->checkPattern(_tokenVal))
      {
         _token = pS->getToken();
         return true;
      }
      pS=_scannerList.Next();
   }
   return false;
}
void MySQLParser::setReserved(Token t)
{
   _reservedToken = t;
   _isReserved = true;
}
